=== modified file 'NEWS'
--- NEWS	2008-04-17 15:53:59 +0000
+++ NEWS	2008-04-18 20:30:59 +0000
@@ -26,6 +26,10 @@
     * Avoid muttering every time a child update does not cause a progress bar
       update. (John Arbash Meinel, #213771)
 
+    * ``bzr log -r ..X bzr://`` was failing, because it was getting a request
+      for ``revision_id=None`` which was not a string.
+      (John Arbash Meinel, #211661)
+
     * Severe performance degradation in fetching from knit repositories to
       knits and packs due to parsing the entire revisions.kndx on every graph
       walk iteration fixed by using the Repository.get_graph API.  There was

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2008-03-28 03:54:40 +0000
+++ bzrlib/log.py	2008-04-18 20:30:59 +0000
@@ -464,8 +464,10 @@
     # This asks for all mainline revisions, which means we only have to spider
     # sideways, rather than depth history. That said, its still size-of-history
     # and should be addressed.
+    # mainline_revisions always includes an extra revision at the beginning, so
+    # don't request it.
     parent_map = dict(((key, value) for key, value in
-        graph.iter_ancestry(mainline_revisions) if value is not None))
+        graph.iter_ancestry(mainline_revisions[1:]) if value is not None))
     sorted_rev_list = topo_sort(parent_map.items())
     ancestry = {}
     for rev in sorted_rev_list:

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2008-04-10 16:41:50 +0000
+++ bzrlib/remote.py	2008-04-18 20:30:59 +0000
@@ -859,7 +859,8 @@
         body = self._serialise_search_recipe(recipe)
         path = self.bzrdir._path_for_remote_call(self._client)
         for key in keys:
-            assert type(key) is str
+            assert type(key) is str, \
+                "Key type is %s not a plain string" % (type(key),)
         verb = 'Repository.get_parent_map'
         args = (path,) + tuple(keys)
         try:

